/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type {
  FunctionFragment,
  Result,
  EventFragment,
} from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../common";

export declare namespace IRouter {
  export type PluginStruct = {
    functionSelector: PromiseOrValue<BytesLike>;
    functionSignature: PromiseOrValue<string>;
    pluginAddress: PromiseOrValue<string>;
  };

  export type PluginStructOutput = [string, string, string] & {
    functionSelector: string;
    functionSignature: string;
    pluginAddress: string;
  };
}

export interface OspRouterImmutableInterface extends utils.Interface {
  functions: {
    "ROUTER_STORAGE_POSITION()": FunctionFragment;
    "_getPluginForFunction(bytes4)": FunctionFragment;
    "addPlugin((bytes4,string,address))": FunctionFragment;
    "changeAdmin(address)": FunctionFragment;
    "getAllFunctionsOfPlugin(address)": FunctionFragment;
    "getAllPlugins()": FunctionFragment;
    "getPluginForFunction(bytes4)": FunctionFragment;
    "multicall(bytes[])": FunctionFragment;
    "removePlugin(bytes4,string)": FunctionFragment;
    "supportsInterface(bytes4)": FunctionFragment;
    "updatePlugin((bytes4,string,address))": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "ROUTER_STORAGE_POSITION"
      | "_getPluginForFunction"
      | "addPlugin"
      | "changeAdmin"
      | "getAllFunctionsOfPlugin"
      | "getAllPlugins"
      | "getPluginForFunction"
      | "multicall"
      | "removePlugin"
      | "supportsInterface"
      | "updatePlugin"
  ): FunctionFragment;

  encodeFunctionData(
    functionFragment: "ROUTER_STORAGE_POSITION",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "_getPluginForFunction",
    values: [PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(
    functionFragment: "addPlugin",
    values: [IRouter.PluginStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "changeAdmin",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "getAllFunctionsOfPlugin",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "getAllPlugins",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getPluginForFunction",
    values: [PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(
    functionFragment: "multicall",
    values: [PromiseOrValue<BytesLike>[]]
  ): string;
  encodeFunctionData(
    functionFragment: "removePlugin",
    values: [PromiseOrValue<BytesLike>, PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "supportsInterface",
    values: [PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(
    functionFragment: "updatePlugin",
    values: [IRouter.PluginStruct]
  ): string;

  decodeFunctionResult(
    functionFragment: "ROUTER_STORAGE_POSITION",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "_getPluginForFunction",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "addPlugin", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "changeAdmin",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getAllFunctionsOfPlugin",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getAllPlugins",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getPluginForFunction",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "multicall", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "removePlugin",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "supportsInterface",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "updatePlugin",
    data: BytesLike
  ): Result;

  events: {
    "AdminChanged(address,address)": EventFragment;
    "PluginAdded(bytes4,address)": EventFragment;
    "PluginRemoved(bytes4,address)": EventFragment;
    "PluginSet(bytes4,string,address)": EventFragment;
    "PluginUpdated(bytes4,address,address)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "AdminChanged"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "PluginAdded"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "PluginRemoved"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "PluginSet"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "PluginUpdated"): EventFragment;
}

export interface AdminChangedEventObject {
  previousAdmin: string;
  newAdmin: string;
}
export type AdminChangedEvent = TypedEvent<
  [string, string],
  AdminChangedEventObject
>;

export type AdminChangedEventFilter = TypedEventFilter<AdminChangedEvent>;

export interface PluginAddedEventObject {
  functionSelector: string;
  pluginAddress: string;
}
export type PluginAddedEvent = TypedEvent<
  [string, string],
  PluginAddedEventObject
>;

export type PluginAddedEventFilter = TypedEventFilter<PluginAddedEvent>;

export interface PluginRemovedEventObject {
  functionSelector: string;
  pluginAddress: string;
}
export type PluginRemovedEvent = TypedEvent<
  [string, string],
  PluginRemovedEventObject
>;

export type PluginRemovedEventFilter = TypedEventFilter<PluginRemovedEvent>;

export interface PluginSetEventObject {
  functionSelector: string;
  functionSignature: string;
  pluginAddress: string;
}
export type PluginSetEvent = TypedEvent<
  [string, string, string],
  PluginSetEventObject
>;

export type PluginSetEventFilter = TypedEventFilter<PluginSetEvent>;

export interface PluginUpdatedEventObject {
  functionSelector: string;
  oldPluginAddress: string;
  newPluginAddress: string;
}
export type PluginUpdatedEvent = TypedEvent<
  [string, string, string],
  PluginUpdatedEventObject
>;

export type PluginUpdatedEventFilter = TypedEventFilter<PluginUpdatedEvent>;

export interface OspRouterImmutable extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: OspRouterImmutableInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    ROUTER_STORAGE_POSITION(overrides?: CallOverrides): Promise<[string]>;

    _getPluginForFunction(
      _selector: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[string]>;

    addPlugin(
      _plugin: IRouter.PluginStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    changeAdmin(
      _admin: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    getAllFunctionsOfPlugin(
      _pluginAddress: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[string[]] & { registered: string[] }>;

    getAllPlugins(overrides?: CallOverrides): Promise<
      [IRouter.PluginStructOutput[]] & {
        registered: IRouter.PluginStructOutput[];
      }
    >;

    getPluginForFunction(
      _selector: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[string]>;

    multicall(
      data: PromiseOrValue<BytesLike>[],
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    removePlugin(
      selector: PromiseOrValue<BytesLike>,
      functionSignature: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    supportsInterface(
      interfaceId: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    updatePlugin(
      _plugin: IRouter.PluginStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;
  };

  ROUTER_STORAGE_POSITION(overrides?: CallOverrides): Promise<string>;

  _getPluginForFunction(
    _selector: PromiseOrValue<BytesLike>,
    overrides?: CallOverrides
  ): Promise<string>;

  addPlugin(
    _plugin: IRouter.PluginStruct,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  changeAdmin(
    _admin: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  getAllFunctionsOfPlugin(
    _pluginAddress: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<string[]>;

  getAllPlugins(
    overrides?: CallOverrides
  ): Promise<IRouter.PluginStructOutput[]>;

  getPluginForFunction(
    _selector: PromiseOrValue<BytesLike>,
    overrides?: CallOverrides
  ): Promise<string>;

  multicall(
    data: PromiseOrValue<BytesLike>[],
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  removePlugin(
    selector: PromiseOrValue<BytesLike>,
    functionSignature: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  supportsInterface(
    interfaceId: PromiseOrValue<BytesLike>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  updatePlugin(
    _plugin: IRouter.PluginStruct,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    ROUTER_STORAGE_POSITION(overrides?: CallOverrides): Promise<string>;

    _getPluginForFunction(
      _selector: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<string>;

    addPlugin(
      _plugin: IRouter.PluginStruct,
      overrides?: CallOverrides
    ): Promise<void>;

    changeAdmin(
      _admin: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    getAllFunctionsOfPlugin(
      _pluginAddress: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<string[]>;

    getAllPlugins(
      overrides?: CallOverrides
    ): Promise<IRouter.PluginStructOutput[]>;

    getPluginForFunction(
      _selector: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<string>;

    multicall(
      data: PromiseOrValue<BytesLike>[],
      overrides?: CallOverrides
    ): Promise<string[]>;

    removePlugin(
      selector: PromiseOrValue<BytesLike>,
      functionSignature: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    supportsInterface(
      interfaceId: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    updatePlugin(
      _plugin: IRouter.PluginStruct,
      overrides?: CallOverrides
    ): Promise<void>;
  };

  filters: {
    "AdminChanged(address,address)"(
      previousAdmin?: null,
      newAdmin?: null
    ): AdminChangedEventFilter;
    AdminChanged(
      previousAdmin?: null,
      newAdmin?: null
    ): AdminChangedEventFilter;

    "PluginAdded(bytes4,address)"(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      pluginAddress?: PromiseOrValue<string> | null
    ): PluginAddedEventFilter;
    PluginAdded(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      pluginAddress?: PromiseOrValue<string> | null
    ): PluginAddedEventFilter;

    "PluginRemoved(bytes4,address)"(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      pluginAddress?: PromiseOrValue<string> | null
    ): PluginRemovedEventFilter;
    PluginRemoved(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      pluginAddress?: PromiseOrValue<string> | null
    ): PluginRemovedEventFilter;

    "PluginSet(bytes4,string,address)"(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      functionSignature?: PromiseOrValue<string> | null,
      pluginAddress?: PromiseOrValue<string> | null
    ): PluginSetEventFilter;
    PluginSet(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      functionSignature?: PromiseOrValue<string> | null,
      pluginAddress?: PromiseOrValue<string> | null
    ): PluginSetEventFilter;

    "PluginUpdated(bytes4,address,address)"(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      oldPluginAddress?: PromiseOrValue<string> | null,
      newPluginAddress?: PromiseOrValue<string> | null
    ): PluginUpdatedEventFilter;
    PluginUpdated(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      oldPluginAddress?: PromiseOrValue<string> | null,
      newPluginAddress?: PromiseOrValue<string> | null
    ): PluginUpdatedEventFilter;
  };

  estimateGas: {
    ROUTER_STORAGE_POSITION(overrides?: CallOverrides): Promise<BigNumber>;

    _getPluginForFunction(
      _selector: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    addPlugin(
      _plugin: IRouter.PluginStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    changeAdmin(
      _admin: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    getAllFunctionsOfPlugin(
      _pluginAddress: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getAllPlugins(overrides?: CallOverrides): Promise<BigNumber>;

    getPluginForFunction(
      _selector: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    multicall(
      data: PromiseOrValue<BytesLike>[],
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    removePlugin(
      selector: PromiseOrValue<BytesLike>,
      functionSignature: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    supportsInterface(
      interfaceId: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    updatePlugin(
      _plugin: IRouter.PluginStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    ROUTER_STORAGE_POSITION(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    _getPluginForFunction(
      _selector: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    addPlugin(
      _plugin: IRouter.PluginStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    changeAdmin(
      _admin: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    getAllFunctionsOfPlugin(
      _pluginAddress: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getAllPlugins(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    getPluginForFunction(
      _selector: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    multicall(
      data: PromiseOrValue<BytesLike>[],
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    removePlugin(
      selector: PromiseOrValue<BytesLike>,
      functionSignature: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    supportsInterface(
      interfaceId: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    updatePlugin(
      _plugin: IRouter.PluginStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;
  };
}
